#include <stdio.h>
#include <math.h>
#include <malloc.h>

#define NUMBER_OF_ROT 17  /*nombre de rotations autour de Ou, premier axe du rep. objet*/
#define NUMBER_OF_TRANS 1 /*nombre de translations suivant Cz, axe optique*/
#define TRANS_MIN 500     /*premiere des translations suivant Cz. Unites du rep. objet*/
#define TRANS_STEP 100    /*increment des translations suivant Cz*/

static double x;

#define round(a) (x=(a),(fabs(x - ceil(x))) < (fabs(x - floor(x))) ? \
(ceil(x)) : (floor(x)))

/*******************************************************************************************************/
main() /*donnee des points objets, focale et amplitude du bruit*/
{
long int NumberOfPoints,i;
double **object,f=760.0;     /*f: longueur focale, en pixels*/
double ampl_noise=1.0;       /*ampl_noise: amplitude pour le generateur aleatoire uniforme de bruit:*/
                             /*0.0->bruit de quantification seul*/
                             /*1.0->+ ou - 1 pixel en plus => ecart jusqu'a 1.5 pixel*/
                             /*2.0->+ ou - 2 pixel en plus => ecart jusqu'a 2.5 pixel*/
void AllRotTransErrors();


NumberOfPoints=10;           /*nombre de points utilises: a changer si != 10*/

object=(double **)malloc(NumberOfPoints * sizeof(double *));
for (i=0;i<NumberOfPoints;i++) object[i]=(double *)malloc(3 * sizeof(double));

/*grille de 121 points objets dans le carre (|U|<=50)&(|V|<=50)&(W=0);*/
/*for (i=0;i<NumberOfPoints;i++)*/ 
/*{*/
/*  object[i][1]=10.0*floor((double)i/11.0)-50.0;*/
/*  object[i][0]=10.0*((double)i-11.0*floor((double)i/11.0))-50.0;*/
/*  object[i][2]=0.0;*/
/*}*/

/*10 points "aleatoirement" repartis a la main dans ce meme carre (dont deux sommets)*/
object[0][0]=-50.0;
object[0][1]=-50.0;
object[0][2]=0.0;

object[1][0]=-30.0;
object[1][1]=40.0;
object[1][2]=0.0;

object[2][0]=50.0;
object[2][1]=50.0;
object[2][2]=0.0;

object[3][0]=30.0;
object[3][1]=-10.0;
object[3][2]=0.0;

object[4][0]=40.0;
object[4][1]=-40.0;
object[4][2]=0.0;

object[5][0]=-10.0;
object[5][1]=-40.0;
object[5][2]=0.0;

object[6][0]=-20.0;
object[6][1]=10.0;
object[6][2]=0.0;

object[7][0]=20.0;
object[7][1]=30.0;
object[7][2]=0.0;

object[8][0]=-40.0;
object[8][1]=-10.0;
object[8][2]=0.0;

object[9][0]=10.0;
object[9][1]=-20.0;
object[9][2]=0.0;

AllRotTransErrors(NumberOfPoints,object,f,ampl_noise);
}


/*******************************************************************************************************/
void AllRotTransErrors(NPts,bodyPts,fLength,noiseAmplitude) /*boucle pour les differentes translations*/
long int NPts;
double **bodyPts;
double fLength,noiseAmplitude;

{
long int i;
double t,trans[3];
void AverageRotTransErrors();

trans[0]=0.0;
trans[1]=0.0;
for (i=0;i<NUMBER_OF_TRANS;i++)
  {
    t=(double)(TRANS_MIN + i * TRANS_STEP);
    trans[2]=t;    
    /*printf("\nTranslation %d = %f",i,t);*/
    printf("\ntz = %5.0f\n",t);
    AverageRotTransErrors(NPts,bodyPts,trans,fLength,noiseAmplitude);
  }
}

/*******************************************************************************************************/
void AverageRotTransErrors(NP,bodyPts,trans,fLength,noiseAmp) /*processus principal une fois la*/
                                                              /*position fixee. Appelle tous les*/
                                                              /*autres processus, pour les 17 rotations*/
                                                              /*autour de Ou (de 10 a 90 deg. par pas*/
                                                              /*de 5) et les 72 rotations autour de Ow*/
                                                              /*(tour complet: de 0 a 355)*/
long int NP;
double **bodyPts;
double trans[];
double fLength,noiseAmp;

{
long int num,i,j,id=1,rotW,fr;
double rota[3][3],rota1[3][3],transa1[3],rotError1,transError1,nsol;
double listRotErrors1[NUMBER_OF_ROT][3],listTransErrors1[NUMBER_OF_ROT][3];
double listRotEr[72],listTransEr[72],RotErAverageAndStd[2],TransErAverageAndStd[2];
double **ImagePoints,*bodyPtsZ;
double PI=3.1415927;
double aU,aW,az,sign,dev,dec=0.0;

void Rotate2();
void PerspMoveAndProj(); /*cf file Error.c*/
void Composit(); /*cf file Composit.c*/
double GetRotErrorAngle();
double GetTransErrors2();
double ran1(); /*cf file noise.c*/
void GetAverageAndSTD();

bodyPtsZ=(double *)malloc(NP * sizeof(double));
ImagePoints=(double **)malloc(NP * sizeof(double *));
for (i=0;i<NP;i++) ImagePoints[i]=(double *)malloc(2 * sizeof(double));

/*etude de l'influence du defaut de planeite de l'objet*/
/*ATTENTION: les elevations (aleatoires) different a chaque appel de AverageRotTransErrors*/
/*for (i=0;i<NP;i++) */
/*  {*/
/*    bodyPtsZ[i]=15*ran1(&id);*/ /*15 est l'amplitude des elevations aleatoires (unites du rep. objet)*/
/*    printf("\n%f",bodyPtsZ[i]);*/
/*  }*/

for (num=0;num<NUMBER_OF_ROT;num++) /*boucle des 17 rotations de la camera autour de Ou*/
  {
    printf("\nrotation %d",10+num*5);
    /*aU,aW: angles de rotation de la camera par rapport au rep. objet (Ou et Ow, en degres)*/
    /*az: angle de rotation de la camera autour de son axe optique (degres)*/
    aU=10+num*5;
    az=0.0; /*est toujours reste nul pour les essais*/

    for (rotW=0;rotW<360;rotW+=5) /*boucle des 72 rotations autour de Ow*/
      {
	printf("\n%d",rotW);
	aW=(double)rotW;
	Rotate2(aU,aW,az,rota); /*ATTENTION: rota est la matrice de rotation utilisee pour bouger*/
	                        /*l'OBJET par rapport a la CAMERA*/

        /*elevation des points objets pour la synthese de l'image*/
	/*for (i=0;i<NP;i++) bodyPts[i][2]=bodyPtsZ[i];*/

	PerspMoveAndProj(NP,bodyPts,rota,trans,fLength,ImagePoints); /*synthese de l'image TPP*/

	/*quantification+bruit+decentrage eventuel(dec)*/
	for (i=0;i<NP;i++) 
	  {
	    for (j=0;j<2;j++) 
	      {
		sign=ran1(&id);
		dev=round(noiseAmp*ran1(&id));
		if (sign>0.5) ImagePoints[i][j]=round(ImagePoints[i][j])+dev+dec;
		else ImagePoints[i][j]=round(ImagePoints[i][j])-dev+dec;
		/*printf("\n%f",ImagePoints[i][j]);*/
	      }
	  }

	/*annulation des elevations des points objets pour le calcul de la pose (model=carte 2D...)*/
	/*for (i=0;i<NP;i++) bodyPts[i][2]=0.0;*/

	/*appel de POSIT. Retourne le nombre de poses DIFFERENTES acceptables (cf Composit() pour cette*/
	/*notion) en nsol, ainsi que la meilleure pose (rota1, transa1), i.e. la plus proche en*/
	/*rotation (transmission de rota) lorsque 2 sont acceptables, ou celle donnant la plus faible*/
	/*erreur E s'il n'y en a pas 2 acceptables.*/
	Composit(NP,ImagePoints,bodyPts,fLength,rota1,transa1,noiseAmp,rota,&nsol);

	/*for (i=0;i<3;i++) printf("\n%f %f %f",rota[i][0],rota[i][1],rota[i][2]);*/
	/*printf("\n");*/
	/*for (i=0;i<3;i++) printf("\n%f %f %f",rota1[i][0],rota1[i][1],rota1[i][2]);*/

	rotError1=GetRotErrorAngle(rota,rota1); /*calcul et stockage de l'erreur en orientation*/
	listRotEr[rotW/5]=rotError1;
	transError1=GetTransErrors2(trans,transa1); /*calcul et stockage de l'erreur en translation*/
	listTransEr[rotW/5]=transError1;
      }

    /*calcul de la moyenne et std des erreurs sur les 72 rotations, et stockage*/
    GetAverageAndSTD(listRotEr,RotErAverageAndStd);
    GetAverageAndSTD(listTransEr,TransErAverageAndStd);
    listRotErrors1[num][0]=10+num*5;
    listRotErrors1[num][1]=RotErAverageAndStd[0];
    listRotErrors1[num][2]=RotErAverageAndStd[1];
    listTransErrors1[num][0]=10+num*5;
    listTransErrors1[num][1]=TransErAverageAndStd[0];
    listTransErrors1[num][2]=TransErAverageAndStd[1];
  }
/*printf("\nRotations done");*/

/*sortie des resultats dans un format exploitable par MATHEMATICA*/
printf("\nrotEr=");
printf("\n{{%3.0f, %f, %f},",listRotErrors1[0][0],listRotErrors1[0][1],listRotErrors1[0][2]);
for (i=1;i<NUMBER_OF_ROT - 1;i++) printf("\n{%3.0f, %f, %f},",listRotErrors1[i][0],listRotErrors1[i][1],listRotErrors1[i][2]);
printf("\n{%3.0f, %f, %f}};",listRotErrors1[NUMBER_OF_ROT - 1][0],listRotErrors1[NUMBER_OF_ROT - 1][1],listRotErrors1[NUMBER_OF_ROT - 1][2]);
printf("\n");
printf("\ntransEr=");
printf("\n{{%3.0f, %f, %f},",listTransErrors1[0][0],listTransErrors1[0][1],listTransErrors1[0][2]);
for (i=1;i<NUMBER_OF_ROT - 1;i++) printf("\n{%3.0f, %f, %f},",listTransErrors1[i][0],listTransErrors1[i][1],listTransErrors1[i][2]);
printf("\n{%3.0f, %f, %f}};\n\n",listTransErrors1[NUMBER_OF_ROT - 1][0],listTransErrors1[NUMBER_OF_ROT - 1][1],listTransErrors1[NUMBER_OF_ROT - 1][2]);

/*desallocations*/
free(bodyPtsZ);
for (fr=0;fr<NP;fr++) free(ImagePoints[fr]);
}


/*******************************************************************************************************/
void Rotate2(aU,aW,az,R) /*adaptation des donnees (aU, aW: angles de rotations de la camera par rapport*/
                         /*au rep. objet) pour utiliser Rotate() (rotation de l'objet par rapport a la*/
                         /*camera*/
double aU,aW,az;
double R[3][3];
{
long int i,j,k;
double PI=3.1415927;
double RW[3][3],RU[3][3],Rz[3][3],RURW[3][3];
void Rotate();

Rotate(0.0,0.0,-aW*PI/180,RW);
Rotate((aU+90)*PI/180,0.0,0.0,RU);
Rotate(0.0,0.0,az*PI/180,Rz);
for (i=0;i<3;i++)
  {
    for (j=0;j<3;j++)
      {
	RURW[i][j]=0;
	for (k=0;k<3;k++) RURW[i][j]+=RU[i][k]*RW[k][j];
      }
  }
for (i=0;i<3;i++)
  {
    for (j=0;j<3;j++)
      {
	R[i][j]=0;
	for (k=0;k<3;k++) R[i][j]+=Rz[i][k]*RURW[k][j];
      }
  }
}

/*******************************************************************************************************/
void Rotate(ax,ay,az,R) /*retourne la matrice de rotation correspondant a une rotation de az autour de*/
                        /*z, puis ay autour de y, puis ax autour de x dans le sens trigonometrique*/
double ax,ay,az;
double R[3][3];
{
long int i;
double cx,sx,cy,sy,cz,sz;
cx=cos(ax);
sx=sin(ax);
cy=cos(ay);
sy=sin(ay);
cz=cos(az);
sz=sin(az);
R[0][0]=cy*cz;
R[0][1]=-(cy*sz);
R[0][2]=sy;
R[1][0]=cz*sx*sy+cx*sz;
R[1][1]=cx*cz-sx*sy*sz;
R[1][2]=-(cy*sx);
R[2][0]=sx*sz-cx*cz*sy;
R[2][1]=cz*sx+cx*sy*sz;
R[2][2]=cx*cy;
}

/*******************************************************************************************************/
/*void RandomRotate(RR)*/ /*matrice de rotation aleatoire de l'objet par rapport a la camera: inutilise*/
/*double RR[3][3];*/
/*{*/
/*long int i,id=1;*/
/*double ran1();*/
/*double PI=3.1415927;*/
/*double ax,ay,az;*/
/*void Rotate();*/
/*ax=(178*ran1(&id)+91)*PI/180;*/
/*ay=(178*ran1(&id)-89)*PI/180;*/
/*az=(360*ran1(&id))*PI/180;*/
/*Rotate(ax,ay,az,RR);*/
/*}*/

/*******************************************************************************************************/
double GetRotErrorAngle(rotMat1,rotMat2) /*trouve l'angle absolu de rotation entre deux orientations*/
                                         /*definies par leurs matrices. Calcule d'abord l'axe de*/
                                         /*rotation par SVD, puis l'angle par produit vectoriel*/
                                         /*(calcul redondant puis moyennage)*/
double rotMat1[3][3],rotMat2[3][3];
{
double **deltaRot,rotAxis[3],*n1,*n2,angle=0.0,*ad;
long int i,j,smallestDiagIndex = 0,n=0,fr;
double *diagonal,**V;
double PI=3.1415927;
void svdcmp(); /*cf. file svd.c*/
double *UnitVect();
double *CrossProd();
double Norm();

/*allocations*/
V=(double **)malloc(3*sizeof(double *));
diagonal=(double *)malloc(3*sizeof(double));
deltaRot=(double **)malloc(3*sizeof(double *));
for (i=0;i<3;i++)
  {
    V[i]=(double *)malloc(3*sizeof(double));
    deltaRot[i]=(double *)malloc(3*sizeof(double));
  }

for (i=0;i<3;i++)
  {
    for (j=0;j<3;j++) deltaRot[i][j]=rotMat2[i][j]-rotMat1[i][j];
  }

svdcmp(deltaRot,3,3,diagonal,V);

for (i=1;i<3;i++)
  {
    if (diagonal[i]<diagonal[0]) smallestDiagIndex=i;
  }
for (i=0;i<3;i++) rotAxis[i]=V[i][smallestDiagIndex];

if ((Norm(CrossProd(rotMat1[0],rotAxis))!=0.0)&&(Norm(CrossProd(rotMat2[0],rotAxis))!=0.0))
  {
    ad=CrossProd(rotMat1[0],rotAxis);
    n1=UnitVect(ad);
    free(ad);
    ad=CrossProd(rotMat2[0],rotAxis);
    n2=UnitVect(ad);
    free(ad);
    angle+=asin(Norm(CrossProd(n1,n2)))*180/PI;
    n++;
  }

if ((Norm(CrossProd(rotMat1[1],rotAxis))!=0.0)&&(Norm(CrossProd(rotMat2[1],rotAxis))!=0.0))
  {
    ad=CrossProd(rotMat1[0],rotAxis);
    n1=UnitVect(ad);
    free(ad);
    ad=CrossProd(rotMat2[0],rotAxis);
    n2=UnitVect(ad);
    free(ad);
    angle+=asin(Norm(CrossProd(n1,n2)))*180/PI;
    n++;
  }

if ((Norm(CrossProd(rotMat1[2],rotAxis))!=0.0)&&(Norm(CrossProd(rotMat2[2],rotAxis))!=0.0))
  {
    ad=CrossProd(rotMat1[0],rotAxis);
    n1=UnitVect(ad);
    free(ad);
    ad=CrossProd(rotMat2[0],rotAxis);
    n2=UnitVect(ad);
    free(ad);
    angle+=asin(Norm(CrossProd(n1,n2)))*180/PI;
    n++;
  }

/*desallocations*/
free(n1);
free(n2);
for (i=0;i<3;i++) 
  {
    free(V[i]);
    free(deltaRot[i]);
  }
free(diagonal);

return(angle/n);
}


/*******************************************************************************************************/
double GetTransErrors2(transVect1,transVect2) /*calcule l'erreur relative sur la position*/
double transVect1[3],transVect2[3];
{
double vectDiff[3],delta,distanceError;
long int i;
double Norm();
for (i=0;i<3;i++) vectDiff[i]=transVect2[i]-transVect1[i];
delta=Norm(vectDiff);
distanceError=delta/Norm(transVect1);
return(distanceError);
}

/*******************************************************************************************************/
void GetAverageAndSTD(list,averageAndStd) /*calcule moyenne et std d'une liste de valeurs*/
double list[];
double averageAndStd[2];
{

double tot=0.0,tot2=0.0;
long int i,NUMBER=72; /*a ameliorer pour calcul automatique du nombre de valeurs...*/
for (i=0;i<NUMBER;i++) tot+=list[i];
averageAndStd[0]=tot/NUMBER;
for (i=0;i<NUMBER;i++) tot2+=(list[i]-averageAndStd[0])*(list[i]-averageAndStd[0]);
averageAndStd[1]=sqrt(tot2/NUMBER);
}

/*******************************************************************************************************/
double *UnitVect(vector) /*calcul du vecteur unitaire collineaire a un vecteur donne*/
double vector[3];
{
double Norm();
double *vect;
double n;
vect=(double *)malloc(3 * sizeof(double));
n=Norm(vector);
vect[0]=vector[0]/n;
vect[1]=vector[1]/n;
vect[2]=vector[2]/n;
return(vect);
}

/*******************************************************************************************************/
double Norm(vector) /*calcul de la norme d'un vecteur donne*/
double  vector[3];
{
double n;
n=sqrt(vector[0]*vector[0]+vector[1]*vector[1]+vector[2]*vector[2]);
return(n);
}

/*******************************************************************************************************/
double *CrossProd(v1,v2) /*produit vectoriel de deux vecteurs*/
double v1[3],v2[3];
{
double *w;
w=(double *)malloc(3 * sizeof(double));
w[0]=v1[1]*v2[2]-v1[2]*v2[1];
w[1]=v1[2]*v2[0]-v1[0]*v2[2];
w[2]=v1[0]*v2[1]-v1[1]*v2[0];
return(w);
}






















